Page MenuHomePhabricator

Improve citation / Citoid workflow in VisualEditor
Closed, DeclinedPublic

Description

When adding an automatically generated citation in VisualEditor, the user would enter a URL and click on "generate". Afterwards, they need to click on "insert" for the citation to actually be added. However, it is easy to mistakenly assume that the citation is automatically added, and click outside the bubble to dismiss it (without having clicked on "insert"), in part because the [1] shows up as soon as they click on the Cite toolbar button.

Potential solutions:

  • Make it work like adding wikilinks; i.e. automatically insert the citation and have a button for deleting it
  • Use a modal dialogue to require the user to accept or discard an automatically generated citation
  • ...

Event Timeline

wctaiwan created this task.Mar 16 2016, 7:23 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMar 16 2016, 7:23 PM
Jdforrester-WMF closed this task as Declined.Apr 12 2016, 7:31 PM
Jdforrester-WMF added a subscriber: Jdforrester-WMF.

Make it work like adding wikilinks; i.e. automatically insert the citation and have a button for deleting it

That's not how wikilinks work. If you click away without clicking 'Done' it will discard.

This design is intentional, as the least-heavy way to get users to do things. Re-generating the citation is just a click and a paste away, so discarding it is not too bad (and users quickly learnt, in our testing).

That's not how wikilinks work. If you click away without clicking 'Done' it will discard.

That's not quite analogous. First, the wikilink doesn't show up until it's actually inserted. In addition, as you type a wikilink, it starts showing you a list of autocomplete options. Clicking any of them adds the link, as does clicking "Done"--there is a single affirmative action (heh). In the citation workflow, clicking "generate" is already an affirmative action. I don't think it's abnormal for the user to mistakenly think that it's sufficient, especially given that it already shows up as a preview.

(and users quickly learnt, in our testing)

I suppose the existing workflow can be learned if the user edits on a near-daily basis, but I kept hitting it within a single session, and had to relearn it every time I used VE for the first time in a while.

wctaiwan reopened this task as Open.Apr 20 2016, 10:04 PM

I hope I can get a response to my previous comment.

Jdforrester-WMF closed this task as Declined.Apr 26 2016, 7:24 PM

In the citation workflow, clicking "generate" is already an affirmative action. I don't think it's abnormal for the user to mistakenly think that it's sufficient, especially given that it already shows up as a preview.

Possibly. We changed it from "look up", the original wording, because of user confusion. I'm not sure reverting would make it better.

Isarra added a subscriber: Isarra.Apr 26 2016, 7:53 PM

This is strange behaviour. If the normal behaviour is to just have stuff insert and show up immediately (like link behaviour), it needs to be consistent across tools. And given that the entire VE session is a preview anyway, with its own final 'save' action, the normal behaviour of immediate insertion makes more sense anyway - if folks want to cancel a specific thing, that's what deleting it or undo is for. An extra step when adding stuff is inconsistent with user expectations that they're working within a non-final environment.

@Jdforrester-WMF : We got another complaint about this behaviour in the German Wikipedia (https://de.wikipedia.org/wiki/Wikipedia:Technik/Text/Edit/VisualEditor/R%C3%BCckmeldungen#Betreff_Plazierung_eines_Buttons), and I agree with the creator of this task: Discarding all changes without warning when leaving a dialog window should not be the standard behaviour. Especially when the same dialog window is modal for all other types of references (i.e. you can't discard a manually entered reference by leaving the window).